<%@ page import="java.io.*"%>
<%@ page import="java.net.*"%>
<%@ page import="java.util.regex.*"%>

<%!

String getPackageName(){
      return "VitaraCharts";
}

String getPackageSampleChart(){
      return "VitaraHCBarChartMobile";
}

Boolean belongsToPackage(String chart){
      Boolean result = false;
      if (chart.startsWith("Vitara") && !chart.equals(getPackageName())){
            result = true;
      }
      if (getPackageName().contains("Charts") && chart.contains("HCMapChart")) {
            result = false;
      }
      else if (getPackageName().contains("Maps") && !chart.contains("HCMapChart")) {
            result = false;
      }
      return result;
}

String getPluginsRoot(ServletContext ctx){
      return ctx.getRealPath("/") + "/plugins/";
}

String getChartsRoot(ServletContext ctx){
      return getPluginsRoot(ctx) + "VitaraCharts/";
}

String getSourceRoot(ServletContext ctx){
      return getChartsRoot(ctx) + "javascript/mojo/js/source/";
}

String getDebugFilePath(ServletContext ctx){
      return getPluginsRoot(ctx) + "VitaraHCBarChartMobile/javascript/mojo/js/source/VitaraHCBarChartMobile.js";
}

String getMobileServerFilePath(ServletContext ctx, String dir){
      return getPluginsRoot(ctx) + dir + "/javascript/mojo/js/source/MobileServerUrl.js";
}

StringBuffer getMobileConfigURL(HttpServletRequest request){
      StringBuffer result = new StringBuffer();
      String val = request.getParameter("mobileConfigUrl");
      if (val != null){
            result.append(val);
      }
      return result;
}

Boolean isEDMChecked(HttpServletRequest request){
      Boolean result = false;
      String select[] = request.getParameterValues("debugMode");
      if (select != null && select.length > 0) {
            for (int i = 0; i < select.length; i++) {
                  if (select[i].equals("enable")) {
                        result = true;
                  }
            }
      }
      return result;
}

URI extractURI(StringBuffer config) throws URISyntaxException{
      URI result = null;
      int loc = (new String(config)).indexOf('\n');
      while(loc > 0){
            config.replace(loc, loc+1, "<BR>");
            loc = (new String(config)).indexOf('\n');
      }
      Pattern p = Pattern.compile("http.+?(?=servlet|api)", Pattern.CASE_INSENSITIVE);
      Matcher m = p.matcher(config);
      if (m.find()) {
            result = new URI(URLDecoder.decode(m.group()));
      }
      else{
            result = new URI(URLDecoder.decode(config.toString().trim()));
      }
      return result;
}


String[] getDirs(String path){
      File file = new File(path);
      String[] directories = file.list(new FilenameFilter() {
            @Override
            public boolean accept(File current, String name) {
              return new File(current, name).isDirectory();
            }
          });
      return directories;
}

String readFile(String filePath) throws FileNotFoundException, IOException{
      BufferedReader reader = new BufferedReader(new FileReader(filePath));
      StringBuilder sb = new StringBuilder();
      String line;
      while((line = reader.readLine())!= null){
          sb.append(line+"\n");
      }
      reader.close();
      return sb.toString();
}

void createFile(String path, String data) throws IOException{
      FileWriter filewriter = new FileWriter(path, false);
      filewriter.write(data);
      filewriter.close();
}

void deleteFile(String path){
      File mFile = new File(path);
      if (mFile.exists()){
            mFile.delete();
      }
}

String getStringUrlFun(String url, String dirName){
      return "(function(){if(!mstrmojo.plugins." + dirName + ") mstrmojo.plugins."+ dirName +"={};mstrmojo.plugins." + dirName + ".MobileServerUrl=Object;window.getMobileServerURL=function getMobileServerURL(){return '" + url + "';}}());";
}

String getSavedMobileServerURL(ServletContext ctx) throws FileNotFoundException, IOException{
      String result = "";
      String fPath = getMobileServerFilePath(ctx, getPackageSampleChart());
      File mFile = new File(fPath);
      if (mFile.exists()){
            String content = readFile(fPath);
            Pattern p = Pattern.compile("http.+?(?=';})", Pattern.CASE_INSENSITIVE);
            Matcher m = p.matcher(content);
            if (m.find()) {
                  result = m.group();
            }
      }
      return result;
}

Boolean isDebugModeEnabled(ServletContext ctx) throws FileNotFoundException, IOException{
      Boolean result = false;
      String path = getDebugFilePath(ctx);
      String content = readFile(path);
      Pattern p = Pattern.compile("(?<=var isVitaraMobileDebug = )true|false", Pattern.CASE_INSENSITIVE);
      Matcher m = p.matcher(content);
      if (m.find()){
            result = m.group().equalsIgnoreCase("true");
      }
      return result;
}

void setDebugFlag(ServletContext ctx, Boolean bool) throws IOException {
      String path = getDebugFilePath(ctx);
      String content = readFile(path);
      Pattern p = Pattern.compile("var isVitaraMobileDebug\\s*=\\s*true|var isVitaraMobileDebug\\s*=\\s*false", Pattern.CASE_INSENSITIVE);
      Matcher m = p.matcher(content);
      if (m.find()) {
            if (bool) {
                  content = m.replaceFirst("var isVitaraMobileDebug = true");
            }
            else {
                  content = m.replaceFirst("var isVitaraMobileDebug = false");
            }
      }
      createFile(path, content);
}

void insertMobileServerURL(StringBuffer strConfig, ServletContext ctx) throws IOException, URISyntaxException{
      String[] dirs = getDirs(getPluginsRoot(ctx));
      URI mUri = extractURI(strConfig);
      if (mUri != null) {
            for (int i=0; i<dirs.length; i++){
                  if (belongsToPackage(dirs[i])) {
                        createFile(getMobileServerFilePath(ctx, dirs[i]), getStringUrlFun(mUri.toString(), dirs[i]));
                  }
            }
      }
}

void removeMobileServerURL(ServletContext ctx) throws IOException{
      String[] dirs = getDirs(getPluginsRoot(ctx));
      for (int i=0; i<dirs.length; i++){
            if (belongsToPackage(dirs[i])) {
                  deleteFile(getMobileServerFilePath(ctx, dirs[i]));
            }
      }
}

%>
<html>
      <head> 
            <style>
                  .vtrButton {
                        width: 80px;
                        height: 25px;
                  }
                  .inputBox {
                        width: 350px;
                        height: 150px;
                        box-sizing: border-box;
                        border: 1px solid #e0e0e0;
                        border-radius: 4px;
                        background-color: #fcfcfc;
                        padding: 3px;
                        resize: none;
                  }
                  body {
                        font-family: Arial, Helvetica, sans-serif;
                        font-size: 14px;
                  }
                  label {
                        color: blue;
                  }
            </style>
      </head>
      <body>
                 
      <%    
            StringBuffer urlConfig = getMobileConfigURL(request);
            if (urlConfig.toString().trim().length() > 0){
                  insertMobileServerURL(urlConfig, application);
            }
            String savedMobileServerUrl = getSavedMobileServerURL(application);
      %>
            
      <form ACTION="config.jsp">
                  Mobile Configuration URL:<br>
                  <textarea type = "text" name = "mobileConfigUrl" class="inputBox"></textarea> <br> 
                  <label><%=savedMobileServerUrl%></label><br>                      
                  <br>
                  <input class="vtrButton" type="submit" value="Submit">
      </form>
</body>
</html>